"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/chakra.tsx
var chakra_exports = {};
__export(chakra_exports, {
  ___chakra___: () => ___chakra___,
  _chakra: () => _chakra,
  chakra: () => chakra,
  resolveStyles: () => resolveStyles,
  styled: () => styled,
  toCSSObject: () => toCSSObject
});
module.exports = __toCommonJS(chakra_exports);
var import_vue3 = require("vue");
var import_vue4 = require("vue");
var import_styled_system = require("@chakra-ui/styled-system");
var import_utils = require("@chakra-ui/utils");
var import_css2 = require("@emotion/css");

// src/system.utils.ts
var import_css = require("@emotion/css");
var domElements = ["a", "b", "article", "aside", "blockquote", "button", "caption", "cite", "circle", "code", "dd", "div", "dl", "dt", "fieldset", "figcaption", "figure", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "header", "hr", "iframe", "img", "input", "kbd", "label", "li", "mark", "main", "nav", "ol", "p", "path", "pre", "q", "rect", "s", "svg", "section", "select", "strong", "small", "span", "sub", "sup", "table", "tbody", "td", "textarea", "tfoot", "th", "thead", "tr", "ul"];

// src/composables/use-chakra.ts
var import_vue = require("vue");
var import_c_color_mode = require("@chakra-ui/c-color-mode");
var useTheme = /* @__PURE__ */ __name(() => {
  const theme = (0, import_vue.inject)("$chakraTheme");
  return theme;
}, "useTheme");
var useChakra = /* @__PURE__ */ __name(() => {
  const theme = useTheme();
  const {
    colorMode,
    forced
  } = (0, import_c_color_mode.useColorMode)();
  return {
    theme,
    colorMode,
    forced
  };
}, "useChakra");

// src/chakra.tsx
var import_vue_utils = require("@chakra-ui/vue-utils");

// src/chakra.forms.ts
var import_vue2 = require("vue");
var formElements = {
  input: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          ...type === "checkbox" && {
            checked: props.modelValue
          },
          onChange: (event) => {
            if (type === "checkbox") {
              emit("change", !(event == null ? void 0 : event.target).checked, event);
              emit("update:modelValue", !(event == null ? void 0 : event.target).checked, event);
              return;
            }
          },
          onInput: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  },
  textarea: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          onInput: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  },
  select: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          onChange: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  }
};

// src/chakra.tsx
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !(0, import_vue3.isVNode)(s);
}
__name(_isSlot, "_isSlot");
var chakraProps = {
  as: [String, Object],
  __css: Object,
  sx: Object,
  css: Object,
  noOfLines: [String, Number, Object, Array],
  baseStyle: Object,
  isTruncated: Boolean,
  layerStyle: String,
  textStyle: String,
  apply: String,
  label: String,
  modelValue: [String, Number, Object, Array],
  __chakraIsRaw: Boolean
};
function ___chakra___(tag, options = {}) {
  const inputHandlers = formElements[typeof tag === "string" ? tag : ""];
  const _props = inputHandlers && inputHandlers.props || {};
  const handleValueChange = inputHandlers && inputHandlers.handleValueChange;
  return (0, import_vue4.defineComponent)({
    name: `chakra-factory-${String(tag)}`,
    inheritAttrs: false,
    props: {
      ...chakraProps,
      ..._props
    },
    setup(props, {
      slots,
      emit,
      attrs
    }) {
      const {
        theme,
        colorMode,
        forced
      } = useChakra();
      const layerStyle$ = (0, import_vue4.computed)(() => props.layerStyle || (options == null ? void 0 : options.layerStyle));
      const textStyle$ = (0, import_vue4.computed)(() => props.textStyle || (options == null ? void 0 : options.textStyle));
      const baseStyle$ = (0, import_vue4.computed)(() => props.baseStyle || (options == null ? void 0 : options.baseStyle));
      const noOfLines$ = (0, import_vue4.computed)(() => props.noOfLines || (options == null ? void 0 : options.noOfLines));
      const isTruncated$ = (0, import_vue4.computed)(() => props.isTruncated || (options == null ? void 0 : options.isTruncated));
      const __css$ = (0, import_vue4.computed)(() => props.__css || (options == null ? void 0 : options.__css));
      const css$ = (0, import_vue4.computed)(() => props.css || (options == null ? void 0 : options.css));
      const sx$ = (0, import_vue4.computed)(() => props.sx || (options == null ? void 0 : options.sx));
      const apply$ = (0, import_vue4.computed)(() => props.apply || (options == null ? void 0 : options.apply));
      return () => {
        const {
          class: inheritedClass,
          __label,
          ...rest
        } = attrs;
        const {
          layerStyle,
          baseStyle,
          textStyle,
          noOfLines,
          isTruncated,
          __css,
          css: css2,
          sx,
          apply,
          label,
          ...otherStyles
        } = options;
        const {
          styles,
          attrs: elementAttributes
        } = (0, import_vue_utils.extractStyleAttrs)({
          ...otherStyles,
          ...rest
        });
        const resolvedComponentStyles = resolveStyles({
          __css: __css$.value,
          baseStyle: baseStyle$.value,
          apply: apply$.value,
          layerStyle: layerStyle$.value,
          noOfLines: noOfLines$.value,
          isTruncated: isTruncated$.value,
          textStyle: textStyle$.value,
          sx: sx$.value,
          css: css$.value,
          ...styles,
          theme
        });
        const componentLabel = label || __label;
        const _componentName = componentLabel ? `chakra-${componentLabel}` : "";
        const className = (0, import_css2.css)(resolvedComponentStyles);
        let componentOrTag = props.as || tag;
        if (!(0, import_utils.isObject)(componentOrTag) && !domElements.includes(componentOrTag)) {
          componentOrTag = (0, import_vue4.resolveComponent)(componentOrTag);
        }
        const Tag = componentOrTag || props.as;
        return (0, import_vue3.createVNode)(Tag, (0, import_vue3.mergeProps)({
          "class": (0, import_css2.cx)(inheritedClass, _componentName, className)
        }, elementAttributes, {
          "data-theme": forced ? colorMode.value : void 0
        }, !props.__chakraIsRaw && handleValueChange && handleValueChange(props, attrs.type)(emit)), _isSlot(slots) ? slots : {
          default: () => [slots]
        });
      };
    }
  });
}
__name(___chakra___, "___chakra___");
var chakra = Object.assign(___chakra___, domElements.reduce((acc, curr) => {
  acc[curr] = ___chakra___(curr);
  return acc;
}, {}));
var toCSSObject = /* @__PURE__ */ __name((options) => (props) => {
  const {
    theme,
    css: cssProp,
    __css,
    sx,
    ...rest
  } = props;
  const styleProps = (0, import_utils.objectFilter)(rest, (_, prop) => (0, import_styled_system.isStyleProp)(prop));
  const finalStyles = resolveStyles(Object.assign(options, {
    theme
  }, styleProps));
  const computedCSS = (0, import_styled_system.css)(finalStyles)(props.theme);
  return cssProp ? [computedCSS, cssProp] : computedCSS;
}, "toCSSObject");
function styled(component, options) {
  const {
    baseStyle,
    ...styledOptions
  } = options != null ? options : {};
  const styleObject = toCSSObject(options);
  return chakra(component, styledOptions);
}
__name(styled, "styled");
var _chakra = styled;
var resolveStyles = /* @__PURE__ */ __name((resolvers = {}) => {
  const {
    layerStyle,
    baseStyle,
    textStyle,
    noOfLines,
    isTruncated,
    __css,
    css: cssProp,
    sx,
    apply,
    theme,
    ...otherStyles
  } = resolvers;
  const _layerStyle = (0, import_utils.memoizedGet)(theme, `layerStyles.${layerStyle}`, {});
  const _textStyle = (0, import_utils.memoizedGet)(theme, `textStyles.${textStyle}`, {});
  let truncateStyle = {};
  if (noOfLines != null) {
    truncateStyle = {
      overflow: "hidden",
      textOverflow: "ellipsis",
      display: "-webkit-box",
      WebkitBoxOrient: "vertical",
      WebkitLineClamp: noOfLines
    };
  } else if (isTruncated) {
    truncateStyle = {
      overflow: "hidden",
      textOverflow: "ellipsis",
      whiteSpace: "nowrap"
    };
  }
  const finalStyles = (0, import_styled_system.css)(Object.assign({}, __css, baseStyle, {
    apply
  }, _layerStyle, _textStyle, truncateStyle, otherStyles, sx))(theme);
  const cssObject = Object.assign(finalStyles, (0, import_utils.isFunction)(cssProp) ? cssProp(theme) : cssProp);
  return cssObject;
}, "resolveStyles");
domElements.forEach((tag) => {
  _chakra[tag] = _chakra(tag);
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ___chakra___,
  _chakra,
  chakra,
  resolveStyles,
  styled,
  toCSSObject
});
