import * as vue from 'vue';
import { ChakraTheme } from '@chakra-ui/theme';

/** Provides theme object in component context */
declare const useTheme: <T extends ChakraTheme = ChakraTheme>() => T;
/** Single hook to provide theme and color mode values */
declare const useChakra: () => {
    theme: ChakraTheme;
    colorMode: vue.ComputedRef<"light" | "dark">;
    forced: boolean | undefined;
};

export { useChakra, useTheme };
